diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-mac.cc ns-3.36/src/wifi/model/wifi-mac.cc
--- ns-3.35/src/wifi/model/wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-mac.cc	2022-04-30 18:23:58.214735300 -0700
@@ -183,25 +646,783 @@
     }
 }
 
+void
+WifiMac::ConfigureStandard (WifiStandard standard)
+{
+  NS_LOG_FUNCTION (this << standard);
+
+  NS_ABORT_IF (standard >= WIFI_STANDARD_80211n && !m_qosSupported);
+
+  SetupFrameExchangeManager (standard);
+}
+
+void
+WifiMac::ConfigurePhyDependentParameters (void)
+{
+  WifiPhyBand band = m_phy->GetPhyBand ();
+  NS_LOG_FUNCTION (this << band);
+
+  uint32_t cwmin = 0;
+  uint32_t cwmax = 0;
+
+  NS_ASSERT (m_phy != 0);
+  WifiStandard standard = m_phy->GetStandard ();
+
+  if (standard == WIFI_STANDARD_80211b)
+    {
+      SetDsssSupported (true);
+      cwmin = 31;
+      cwmax = 1023;
+    }
+  else
+    {
+      if (standard >= WIFI_STANDARD_80211g && band == WIFI_PHY_BAND_2_4GHZ)
+        {
+          SetErpSupported (true);
+        }
+
+      cwmin = 15;
+      cwmax = 1023;
+    }
+
+  ConfigureContentionWindow (cwmin, cwmax);
+}
+
+void
+WifiMac::SetupFrameExchangeManager (WifiStandard standard)
+{
+  NS_LOG_FUNCTION (this << standard);
+  NS_ABORT_MSG_IF (standard == WIFI_STANDARD_UNSPECIFIED, "Wifi standard not set");
+
+  if (standard >= WIFI_STANDARD_80211ax)
+    {
+      m_feManager = CreateObject<HeFrameExchangeManager> ();
+    }
+  else if (standard >= WIFI_STANDARD_80211ac)
+    {
+      m_feManager = CreateObject<VhtFrameExchangeManager> ();
+    }
+  else if (standard >= WIFI_STANDARD_80211n)
+    {
+      m_feManager = CreateObject<HtFrameExchangeManager> ();
+    }
+  else if (m_qosSupported)
+    {
+      m_feManager = CreateObject<QosFrameExchangeManager> ();
+    }
+  else
+    {
+      m_feManager = CreateObject<FrameExchangeManager> ();
+    }
+
+  m_feManager->SetWifiMac (this);
+  m_feManager->SetMacTxMiddle (m_txMiddle);
+  m_feManager->SetMacRxMiddle (m_rxMiddle);
+  m_feManager->SetAddress (GetAddress ());
+  m_feManager->SetBssid (GetBssid ());
+  m_feManager->GetWifiTxTimer ().SetMpduResponseTimeoutCallback (MakeCallback (&MpduResponseTimeoutTracedCallback::operator(),
+                                                                               &m_mpduResponseTimeoutCallback));
+  m_feManager->GetWifiTxTimer ().SetPsduResponseTimeoutCallback (MakeCallback (&PsduResponseTimeoutTracedCallback::operator(),
+                                                                               &m_psduResponseTimeoutCallback));
+  m_feManager->GetWifiTxTimer ().SetPsduMapResponseTimeoutCallback (MakeCallback (&PsduMapResponseTimeoutTracedCallback::operator(),
+                                                                                  &m_psduMapResponseTimeoutCallback));
+  m_feManager->SetDroppedMpduCallback (MakeCallback (&DroppedMpduTracedCallback::operator(),
+                                                     &m_droppedMpduCallback));
+  m_feManager->SetAckedMpduCallback (MakeCallback (&MpduTracedCallback::operator(),
+                                                   &m_ackedMpduCallback));
+  m_channelAccessManager->SetupFrameExchangeManager (m_feManager);
+  if (GetQosSupported ())
+    {
+      for (const auto& pair : m_edca)
+        {
+          pair.second->SetQosFrameExchangeManager (DynamicCast<QosFrameExchangeManager> (m_feManager));
+        }
+    }
+}
+
+Ptr<FrameExchangeManager>
+WifiMac::GetFrameExchangeManager (void) const
+{
+  return m_feManager;
+}
+
+void
+WifiMac::SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager)
+{
+  NS_LOG_FUNCTION (this << stationManager);
+  m_stationManager = stationManager;
+}
+
+Ptr<WifiRemoteStationManager>
+WifiMac::GetWifiRemoteStationManager () const
+{
+  return m_stationManager;
+}
+
+void
+WifiMac::SetWifiPhy (const Ptr<WifiPhy> phy)
+{
+  NS_LOG_FUNCTION (this << phy);
+  m_phy = phy;
+  NS_ABORT_MSG_IF (!m_phy->GetOperatingChannel ().IsSet (),
+                   "PHY operating channel must have been set");
+  ConfigurePhyDependentParameters ();
+  m_channelAccessManager->SetupPhyListener (phy);
+  NS_ASSERT (m_feManager != 0);
+  m_feManager->SetWifiPhy (phy);
+}
+
+Ptr<WifiPhy>
+WifiMac::GetWifiPhy (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_phy;
+}
+
+void
+WifiMac::ResetWifiPhy (void)
+{
+  NS_LOG_FUNCTION (this);
+  NS_ASSERT (m_feManager != 0);
+  m_feManager->ResetPhy ();
+  m_channelAccessManager->RemovePhyListener (m_phy);
+  m_phy = 0;
+}
+
+void
+WifiMac::SetQosSupported (bool enable)
+{
+  NS_LOG_FUNCTION (this << enable);
+  NS_ABORT_IF (IsInitialized ());
+  m_qosSupported = enable;
+
+  if (!m_qosSupported)
+    {
+      // create a non-QoS TXOP
+      m_txop = CreateObject<Txop> ();
+      m_txop->SetChannelAccessManager (m_channelAccessManager);
+      m_txop->SetWifiMac (this);
+      m_txop->SetTxMiddle (m_txMiddle);
+      m_txop->SetDroppedMpduCallback (MakeCallback (&DroppedMpduTracedCallback::operator(),
+                                                    &m_droppedMpduCallback));
+    }
+  else
+    {
+      //Construct the EDCAFs. The ordering is important - highest
+      //priority (Table 9-1 UP-to-AC mapping; IEEE 802.11-2012) must be created
+      //first.
+      SetupEdcaQueue (AC_VO);
+      SetupEdcaQueue (AC_VI);
+      SetupEdcaQueue (AC_BE);
+      SetupEdcaQueue (AC_BK);
+    }
+}
+
+bool
+WifiMac::GetQosSupported () const
+{
+  return m_qosSupported;
+}
+
+bool
+WifiMac::GetErpSupported () const
+{
+  return m_erpSupported;
+}
+
+void
+WifiMac::SetErpSupported (bool enable)
+{
+  NS_LOG_FUNCTION (this);
+  if (enable)
+    {
+      SetDsssSupported (true);
+    }
+  m_erpSupported = enable;
+}
+
+void
+WifiMac::SetDsssSupported (bool enable)
+{
+  NS_LOG_FUNCTION (this);
+  m_dsssSupported = enable;
+}
+
+bool
+WifiMac::GetDsssSupported () const
+{
+  return m_dsssSupported;
+}
+
+void
+WifiMac::SetCtsToSelfSupported (bool enable)
+{
+  NS_LOG_FUNCTION (this);
+  m_ctsToSelfSupported = enable;
+}
+
+void
+WifiMac::SetShortSlotTimeSupported (bool enable)
+{
+  NS_LOG_FUNCTION (this << enable);
+  m_shortSlotTimeSupported = enable;
+}
+
+bool
+WifiMac::GetShortSlotTimeSupported (void) const
+{
+  return m_shortSlotTimeSupported;
+}
+
+bool
+WifiMac::SupportsSendFrom (void) const
+{
+  return false;
+}
+
+void
+WifiMac::SetForwardUpCallback (ForwardUpCallback upCallback)
+{
+  NS_LOG_FUNCTION (this);
+  m_forwardUp = upCallback;
+}
+
+void
+WifiMac::SetLinkUpCallback (Callback<void> linkUp)
+{
+  NS_LOG_FUNCTION (this);
+  m_linkUp = linkUp;
+}
+
+void
+WifiMac::SetLinkDownCallback (Callback<void> linkDown)
+{
+  NS_LOG_FUNCTION (this);
+  m_linkDown = linkDown;
+}
+
+void
+WifiMac::Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from)
+{
+  //We expect WifiMac subclasses which do support forwarding (e.g.,
+  //AP) to override this method. Therefore, we throw a fatal error if
+  //someone tries to invoke this method on a class which has not done
+  //this.
+  NS_FATAL_ERROR ("This MAC entity (" << this << ", " << GetAddress ()
+                                      << ") does not support Enqueue() with from address");
+}
+
+void
+WifiMac::ForwardUp (Ptr<const Packet> packet, Mac48Address from, Mac48Address to)
+{
+  NS_LOG_FUNCTION (this << packet << from << to);
+  m_forwardUp (packet, from, to);
+}
+
+void
+WifiMac::Receive (Ptr<WifiMacQueueItem> mpdu)
+{
+  NS_LOG_FUNCTION (this << *mpdu);
+
+  const WifiMacHeader* hdr = &mpdu->GetHeader ();
+  Ptr<Packet> packet = mpdu->GetPacket ()->Copy ();
+  Mac48Address to = hdr->GetAddr1 ();
+  Mac48Address from = hdr->GetAddr2 ();
+
+  //We don't know how to deal with any frame that is not addressed to
+  //us (and odds are there is nothing sensible we could do anyway),
+  //so we ignore such frames.
+  //
+  //The derived class may also do some such filtering, but it doesn't
+  //hurt to have it here too as a backstop.
+  if (to != GetAddress ())
+    {
+      return;
+    }
+
+  if (hdr->IsMgt () && hdr->IsAction ())
+    {
+      //There is currently only any reason for Management Action
+      //frames to be flying about if we are a QoS STA.
+      NS_ASSERT (GetQosSupported ());
+
+      WifiActionHeader actionHdr;
+      packet->RemoveHeader (actionHdr);
+
+      switch (actionHdr.GetCategory ())
+        {
+        case WifiActionHeader::BLOCK_ACK:
+
+          switch (actionHdr.GetAction ().blockAck)
+            {
+            case WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST:
+              {
+                MgtAddBaRequestHeader reqHdr;
+                packet->RemoveHeader (reqHdr);
+
+                //We've received an ADDBA Request. Our policy here is
+                //to automatically accept it, so we get the ADDBA
+                //Response on it's way immediately.
+                NS_ASSERT (m_feManager != 0);
+                Ptr<HtFrameExchangeManager> htFem = DynamicCast<HtFrameExchangeManager> (m_feManager);
+                if (htFem != 0)
+                  {
+                    htFem->SendAddBaResponse (&reqHdr, from);
+                  }
+                //This frame is now completely dealt with, so we're done.
+                return;
+              }
+            case WifiActionHeader::BLOCK_ACK_ADDBA_RESPONSE:
+              {
+                MgtAddBaResponseHeader respHdr;
+                packet->RemoveHeader (respHdr);
+
+                //We've received an ADDBA Response. We assume that it
+                //indicates success after an ADDBA Request we have
+                //sent (we could, in principle, check this, but it
+                //seems a waste given the level of the current model)
+                //and act by locally establishing the agreement on
+                //the appropriate queue.
+                GetQosTxop (respHdr.GetTid ())->GotAddBaResponse (&respHdr, from);
+                auto htFem = DynamicCast<HtFrameExchangeManager> (m_feManager);
+                if (htFem != 0)
+                  {
+                    GetQosTxop (respHdr.GetTid ())->GetBaManager ()->SetBlockAckInactivityCallback (MakeCallback (&HtFrameExchangeManager::SendDelbaFrame, htFem));
+                  }
+                //This frame is now completely dealt with, so we're done.
+                return;
+              }
+            case WifiActionHeader::BLOCK_ACK_DELBA:
+              {
+                MgtDelBaHeader delBaHdr;
+                packet->RemoveHeader (delBaHdr);
+
+                if (delBaHdr.IsByOriginator ())
+                  {
+                    //This DELBA frame was sent by the originator, so
+                    //this means that an ingoing established
+                    //agreement exists in HtFrameExchangeManager and we need to
+                    //destroy it.
+                    NS_ASSERT (m_feManager != 0);
+                    Ptr<HtFrameExchangeManager> htFem = DynamicCast<HtFrameExchangeManager> (m_feManager);
+                    if (htFem != 0)
+                      {
+                        htFem->DestroyBlockAckAgreement (from, delBaHdr.GetTid ());
+                      }
+                  }
+                else
+                  {
+                    //We must have been the originator. We need to
+                    //tell the correct queue that the agreement has
+                    //been torn down
+                    GetQosTxop (delBaHdr.GetTid ())->GotDelBaFrame (&delBaHdr, from);
+                  }
+                //This frame is now completely dealt with, so we're done.
+                return;
+              }
+            default:
+              NS_FATAL_ERROR ("Unsupported Action field in Block Ack Action frame");
+              return;
+            }
+        default:
+          NS_FATAL_ERROR ("Unsupported Action frame received");
+          return;
+        }
+    }
+  NS_FATAL_ERROR ("Don't know how to handle frame (type=" << hdr->GetType ());
+}
+
+void
+WifiMac::DeaggregateAmsduAndForward (Ptr<WifiMacQueueItem> mpdu)
+{
+  NS_LOG_FUNCTION (this << *mpdu);
+  for (auto& msduPair : *PeekPointer (mpdu))
+    {
+      ForwardUp (msduPair.first, msduPair.second.GetSourceAddr (),
+                 msduPair.second.GetDestinationAddr ());
+    }
+}
+
 Ptr<HtConfiguration>
 WifiMac::GetHtConfiguration (void) const
 {
-      Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-      return device->GetHtConfiguration ();
+  return GetDevice ()->GetHtConfiguration ();
 }
 
 Ptr<VhtConfiguration>
 WifiMac::GetVhtConfiguration (void) const
 {
-      Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-      return device->GetVhtConfiguration ();
+  return GetDevice ()->GetVhtConfiguration ();
 }
 
 Ptr<HeConfiguration>
 WifiMac::GetHeConfiguration (void) const
 {
-      Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-      return device->GetHeConfiguration ();
+  return GetDevice ()->GetHeConfiguration ();
+}
+
+bool
+WifiMac::GetHtSupported () const
+{
+  if (GetHtConfiguration ())
+    {
+      return true;
+    }
+  return false;
+}
+
+bool
+WifiMac::GetVhtSupported () const
+{
+  if (GetVhtConfiguration ())
+    {
+      return true;
+    }
+  return false;
+}
+
+bool
+WifiMac::GetHeSupported () const
+{
+  if (GetHeConfiguration ())
+    {
+      return true;
+    }
+  return false;
+}
+
+void
+WifiMac::SetVoBlockAckThreshold (uint8_t threshold)
+{
+  NS_LOG_FUNCTION (this << +threshold);
+  if (m_qosSupported)
+    {
+      GetVOQueue ()->SetBlockAckThreshold (threshold);
+    }
+}
+
+void
+WifiMac::SetViBlockAckThreshold (uint8_t threshold)
+{
+  NS_LOG_FUNCTION (this << +threshold);
+  if (m_qosSupported)
+    {
+      GetVIQueue ()->SetBlockAckThreshold (threshold);
+    }
+}
+
+void
+WifiMac::SetBeBlockAckThreshold (uint8_t threshold)
+{
+  NS_LOG_FUNCTION (this << +threshold);
+  if (m_qosSupported)
+    {
+      GetBEQueue ()->SetBlockAckThreshold (threshold);
+    }
+}
+
+void
+WifiMac::SetBkBlockAckThreshold (uint8_t threshold)
+{
+  NS_LOG_FUNCTION (this << +threshold);
+  if (m_qosSupported)
+    {
+      GetBKQueue ()->SetBlockAckThreshold (threshold);
+    }
+}
+
+void
+WifiMac::SetVoBlockAckInactivityTimeout (uint16_t timeout)
+{
+  NS_LOG_FUNCTION (this << timeout);
+  if (m_qosSupported)
+    {
+      GetVOQueue ()->SetBlockAckInactivityTimeout (timeout);
+    }
+}
+
+void
+WifiMac::SetViBlockAckInactivityTimeout (uint16_t timeout)
+{
+  NS_LOG_FUNCTION (this << timeout);
+  if (m_qosSupported)
+    {
+      GetVIQueue ()->SetBlockAckInactivityTimeout (timeout);
+    }
+}
+
+void
+WifiMac::SetBeBlockAckInactivityTimeout (uint16_t timeout)
+{
+  NS_LOG_FUNCTION (this << timeout);
+  if (m_qosSupported)
+    {
+      GetBEQueue ()->SetBlockAckInactivityTimeout (timeout);
+    }
+}
+
+void
+WifiMac::SetBkBlockAckInactivityTimeout (uint16_t timeout)
+{
+  NS_LOG_FUNCTION (this << timeout);
+  if (m_qosSupported)
+    {
+      GetBKQueue ()->SetBlockAckInactivityTimeout (timeout);
+    }
+}
+
+ExtendedCapabilities
+WifiMac::GetExtendedCapabilities (void) const
+{
+  NS_LOG_FUNCTION (this);
+  ExtendedCapabilities capabilities;
+  capabilities.SetHtSupported (GetHtSupported ());
+  capabilities.SetVhtSupported (GetVhtSupported ());
+  //TODO: to be completed
+  return capabilities;
+}
+
+HtCapabilities
+WifiMac::GetHtCapabilities (void) const
+{
+  NS_LOG_FUNCTION (this);
+  HtCapabilities capabilities;
+  if (GetHtSupported ())
+    {
+      Ptr<HtConfiguration> htConfiguration = GetHtConfiguration ();
+      bool sgiSupported = htConfiguration->GetShortGuardIntervalSupported ();
+      capabilities.SetHtSupported (1);
+      capabilities.SetLdpc (htConfiguration->GetLdpcSupported ());
+      capabilities.SetSupportedChannelWidth (GetWifiPhy ()->GetChannelWidth () >= 40);
+      capabilities.SetShortGuardInterval20 (sgiSupported);
+      capabilities.SetShortGuardInterval40 (GetWifiPhy ()->GetChannelWidth () >= 40 && sgiSupported);
+      // Set Maximum A-MSDU Length subfield
+      uint16_t maxAmsduSize = std::max ({m_voMaxAmsduSize, m_viMaxAmsduSize,
+                                         m_beMaxAmsduSize, m_bkMaxAmsduSize});
+      if (maxAmsduSize <= 3839)
+        {
+          capabilities.SetMaxAmsduLength (3839);
+        }
+      else
+        {
+          capabilities.SetMaxAmsduLength (7935);
+        }
+      uint32_t maxAmpduLength = std::max ({m_voMaxAmpduSize, m_viMaxAmpduSize,
+                                           m_beMaxAmpduSize, m_bkMaxAmpduSize});
+      // round to the next power of two minus one
+      maxAmpduLength = (1ul << static_cast<uint32_t> (std::ceil (std::log2 (maxAmpduLength + 1)))) - 1;
+      // The maximum A-MPDU length in HT capabilities elements ranges from 2^13-1 to 2^16-1
+      capabilities.SetMaxAmpduLength (std::min (std::max (maxAmpduLength, 8191u), 65535u));
+
+      capabilities.SetLSigProtectionSupport (true);
+      uint64_t maxSupportedRate = 0; //in bit/s
+      for (const auto & mcs : GetWifiPhy ()->GetMcsList (WIFI_MOD_CLASS_HT))
+        {
+          capabilities.SetRxMcsBitmask (mcs.GetMcsValue ());
+          uint8_t nss = (mcs.GetMcsValue () / 8) + 1;
+          NS_ASSERT (nss > 0 && nss < 5);
+          uint64_t dataRate = mcs.GetDataRate (GetWifiPhy ()->GetChannelWidth (), sgiSupported ? 400 : 800, nss);
+          if (dataRate > maxSupportedRate)
+            {
+              maxSupportedRate = dataRate;
+              NS_LOG_DEBUG ("Updating maxSupportedRate to " << maxSupportedRate);
+            }
+        }
+      capabilities.SetRxHighestSupportedDataRate (static_cast<uint16_t> (maxSupportedRate / 1e6)); //in Mbit/s
+      capabilities.SetTxMcsSetDefined (GetWifiPhy ()->GetNMcs () > 0);
+      capabilities.SetTxMaxNSpatialStreams (GetWifiPhy ()->GetMaxSupportedTxSpatialStreams ());
+      //we do not support unequal modulations
+      capabilities.SetTxRxMcsSetUnequal (0);
+      capabilities.SetTxUnequalModulation (0);
+    }
+  return capabilities;
+}
+
+VhtCapabilities
+WifiMac::GetVhtCapabilities (void) const
+{
+  NS_LOG_FUNCTION (this);
+  VhtCapabilities capabilities;
+  if (GetVhtSupported ())
+    {
+      Ptr<HtConfiguration> htConfiguration = GetHtConfiguration ();
+      Ptr<VhtConfiguration> vhtConfiguration = GetVhtConfiguration ();
+      bool sgiSupported = htConfiguration->GetShortGuardIntervalSupported ();
+      capabilities.SetVhtSupported (1);
+      if (GetWifiPhy ()->GetChannelWidth () == 160)
+        {
+          capabilities.SetSupportedChannelWidthSet (1);
+        }
+      else
+        {
+          capabilities.SetSupportedChannelWidthSet (0);
+        }
+      // Set Maximum MPDU Length subfield
+      uint16_t maxAmsduSize = std::max ({m_voMaxAmsduSize, m_viMaxAmsduSize,
+                                         m_beMaxAmsduSize, m_bkMaxAmsduSize});
+      if (maxAmsduSize <= 3839)
+        {
+          capabilities.SetMaxMpduLength (3895);
+        }
+      else if (maxAmsduSize <= 7935)
+        {
+          capabilities.SetMaxMpduLength (7991);
+        }
+      else
+        {
+          capabilities.SetMaxMpduLength (11454);
+        }
+      uint32_t maxAmpduLength = std::max ({m_voMaxAmpduSize, m_viMaxAmpduSize,
+                                           m_beMaxAmpduSize, m_bkMaxAmpduSize});
+      // round to the next power of two minus one
+      maxAmpduLength = (1ul << static_cast<uint32_t> (std::ceil (std::log2 (maxAmpduLength + 1)))) - 1;
+      // The maximum A-MPDU length in VHT capabilities elements ranges from 2^13-1 to 2^20-1
+      capabilities.SetMaxAmpduLength (std::min (std::max (maxAmpduLength, 8191u), 1048575u));
+
+      capabilities.SetRxLdpc (htConfiguration->GetLdpcSupported ());
+      capabilities.SetShortGuardIntervalFor80Mhz ((GetWifiPhy ()->GetChannelWidth () == 80) && sgiSupported);
+      capabilities.SetShortGuardIntervalFor160Mhz ((GetWifiPhy ()->GetChannelWidth () == 160) && sgiSupported);
+      uint8_t maxMcs = 0;
+      for (const auto & mcs : GetWifiPhy ()->GetMcsList (WIFI_MOD_CLASS_VHT))
+        {
+          if (mcs.GetMcsValue () > maxMcs)
+            {
+              maxMcs = mcs.GetMcsValue ();
+            }
+        }
+      // Support same MaxMCS for each spatial stream
+      for (uint8_t nss = 1; nss <= GetWifiPhy ()->GetMaxSupportedRxSpatialStreams (); nss++)
+        {
+          capabilities.SetRxMcsMap (maxMcs, nss);
+        }
+      for (uint8_t nss = 1; nss <= GetWifiPhy ()->GetMaxSupportedTxSpatialStreams (); nss++)
+        {
+          capabilities.SetTxMcsMap (maxMcs, nss);
+        }
+      uint64_t maxSupportedRateLGI = 0; //in bit/s
+      for (const auto & mcs : GetWifiPhy ()->GetMcsList (WIFI_MOD_CLASS_VHT))
+        {
+          if (!mcs.IsAllowed (GetWifiPhy ()->GetChannelWidth (), 1))
+            {
+              continue;
+            }
+          if (mcs.GetDataRate (GetWifiPhy ()->GetChannelWidth ()) > maxSupportedRateLGI)
+            {
+              maxSupportedRateLGI = mcs.GetDataRate (GetWifiPhy ()->GetChannelWidth ());
+              NS_LOG_DEBUG ("Updating maxSupportedRateLGI to " << maxSupportedRateLGI);
+            }
+        }
+      capabilities.SetRxHighestSupportedLgiDataRate (static_cast<uint16_t> (maxSupportedRateLGI / 1e6)); //in Mbit/s
+      capabilities.SetTxHighestSupportedLgiDataRate (static_cast<uint16_t> (maxSupportedRateLGI / 1e6)); //in Mbit/s
+      //To be filled in once supported
+      capabilities.SetRxStbc (0);
+      capabilities.SetTxStbc (0);
+    }
+  return capabilities;
+}
+
+HeCapabilities
+WifiMac::GetHeCapabilities (void) const
+{
+  NS_LOG_FUNCTION (this);
+  HeCapabilities capabilities;
+  if (GetHeSupported ())
+    {
+      Ptr<HtConfiguration> htConfiguration = GetHtConfiguration ();
+      Ptr<HeConfiguration> heConfiguration = GetHeConfiguration ();
+      capabilities.SetHeSupported (1);
+      uint8_t channelWidthSet = 0;
+      if ((m_phy->GetChannelWidth () >= 40) && (m_phy->GetPhyBand () == WIFI_PHY_BAND_2_4GHZ))
+        {
+          channelWidthSet |= 0x01;
+        }
+      if ((m_phy->GetChannelWidth () >= 80) && ((m_phy->GetPhyBand () == WIFI_PHY_BAND_5GHZ) || (m_phy->GetPhyBand () == WIFI_PHY_BAND_6GHZ)))
+        {
+          channelWidthSet |= 0x02;
+        }
+      if ((m_phy->GetChannelWidth () >= 160) && ((m_phy->GetPhyBand () == WIFI_PHY_BAND_5GHZ) || (m_phy->GetPhyBand () == WIFI_PHY_BAND_6GHZ)))
+        {
+          channelWidthSet |= 0x04;
+        }
+      capabilities.SetChannelWidthSet (channelWidthSet);
+      capabilities.SetLdpcCodingInPayload (htConfiguration->GetLdpcSupported ());
+      if (heConfiguration->GetGuardInterval () == NanoSeconds (800))
+        {
+          //todo: We assume for now that if we support 800ns GI then 1600ns GI is supported as well
+          //todo: Assuming reception support for both 1x HE LTF and 4x HE LTF 800 ns
+          capabilities.SetHeSuPpdu1xHeLtf800nsGi (true);
+          capabilities.SetHePpdu4xHeLtf800nsGi (true);
+        }
+
+      uint32_t maxAmpduLength = std::max ({m_voMaxAmpduSize, m_viMaxAmpduSize,
+                                           m_beMaxAmpduSize, m_bkMaxAmpduSize});
+      // round to the next power of two minus one
+      maxAmpduLength = (1ul << static_cast<uint32_t> (std::ceil (std::log2 (maxAmpduLength + 1)))) - 1;
+      // The maximum A-MPDU length in HE capabilities elements ranges from 2^20-1 to 2^23-1
+      capabilities.SetMaxAmpduLength (std::min (std::max (maxAmpduLength, 1048575u), 8388607u));
+
+      uint8_t maxMcs = 0;
+      for (const auto & mcs : m_phy->GetMcsList (WIFI_MOD_CLASS_HE))
+        {
+          if (mcs.GetMcsValue () > maxMcs)
+            {
+              maxMcs = mcs.GetMcsValue ();
+            }
+        }
+      capabilities.SetHighestMcsSupported (maxMcs);
+      capabilities.SetHighestNssSupported (m_phy->GetMaxSupportedTxSpatialStreams ());
+    }
+  return capabilities;
+}
+
+uint32_t
+WifiMac::GetMaxAmpduSize (AcIndex ac) const
+{
+  uint32_t maxSize = 0;
+  switch (ac)
+    {
+      case AC_BE:
+        maxSize = m_beMaxAmpduSize;
+        break;
+      case AC_BK:
+        maxSize = m_bkMaxAmpduSize;
+        break;
+      case AC_VI:
+        maxSize = m_viMaxAmpduSize;
+        break;
+      case AC_VO:
+        maxSize = m_voMaxAmpduSize;
+        break;
+      default:
+        NS_ABORT_MSG ("Unknown AC " << ac);
+        return 0;
+    }
+  return maxSize;
+}
+
+uint16_t
+WifiMac::GetMaxAmsduSize (AcIndex ac) const
+{
+  uint16_t maxSize = 0;
+  switch (ac)
+    {
+      case AC_BE:
+        maxSize = m_beMaxAmsduSize;
+        break;
+      case AC_BK:
+        maxSize = m_bkMaxAmsduSize;
+        break;
+      case AC_VI:
+        maxSize = m_viMaxAmsduSize;
+        break;
+      case AC_VO:
+        maxSize = m_voMaxAmsduSize;
+        break;
+      default:
+        NS_ABORT_MSG ("Unknown AC " << ac);
+        return 0;
+    }
+  return maxSize;
 }
 
 } //namespace ns3
